diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/l10n.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/l10n.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/l10n.php	2012-10-31 16:30:33.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/l10n.php	2013-09-30 14:47:12.000000000 -0500
***************
*** 401,451 ****
  }
  
  /**
!  * Loads the plugin's translated strings.
   *
   * If the path is not given then it will be the root of the plugin directory.
!  * The .mo file should be named based on the domain with a dash, and then the locale exactly.
   *
   * @since 1.5.0
   *
!  * @param string $domain Unique identifier for retrieving translated strings
!  * @param string $abs_rel_path Optional. Relative path to ABSPATH of a folder,
!  * 	where the .mo file resides. Deprecated, but still functional until 2.7
!  * @param string $plugin_rel_path Optional. Relative path to WP_PLUGIN_DIR. This is the preferred argument to use. It takes precedence over $abs_rel_path
   */
! function load_plugin_textdomain( $domain, $abs_rel_path = false, $plugin_rel_path = false ) {
! 	$locale = apply_filters( 'plugin_locale', get_locale(), $domain );
  
  	if ( false !== $plugin_rel_path	) {
  		$path = WP_PLUGIN_DIR . '/' . trim( $plugin_rel_path, '/' );
! 	} else if ( false !== $abs_rel_path ) {
  		_deprecated_argument( __FUNCTION__, '2.7' );
! 		$path = ABSPATH . trim( $abs_rel_path, '/' );
  	} else {
  		$path = WP_PLUGIN_DIR;
  	}
  
! 	$mofile = $path . '/'. $domain . '-' . $locale . '.mo';
  	return load_textdomain( $domain, $mofile );
  }
  
  /**
!  * Load the translated strings for a plugin residing in the mu-plugins dir.
   *
   * @since 3.0.0
   *
!  * @param string $domain Unique identifier for retrieving translated strings
!  * @param string $mu_plugin_rel_path Relative to WPMU_PLUGIN_DIR directory in which
!  * the MO file resides. Defaults to empty string.
   */
  function load_muplugin_textdomain( $domain, $mu_plugin_rel_path = '' ) {
  	$locale = apply_filters( 'plugin_locale', get_locale(), $domain );
! 	$path = WPMU_PLUGIN_DIR . '/' . ltrim( $mu_plugin_rel_path, '/' );
! 	load_textdomain( $domain, trailingslashit( $path ) . "$domain-$locale.mo" );
  }
  
  /**
!  * Loads the theme's translated strings.
   *
   * If the current locale exists as a .mo file in the theme's root directory, it
   * will be included in the translated strings by the $domain.
--- 537,612 ----
  }
  
  /**
!  * Load a plugin's translated strings.
   *
   * If the path is not given then it will be the root of the plugin directory.
!  *
!  * The .mo file should be named based on the text domain with a dash, and then the locale exactly.
   *
   * @since 1.5.0
   *
!  * @param string $domain          Unique identifier for retrieving translated strings
!  * @param string $deprecated      Use the $plugin_rel_path parameter instead.
!  * @param string $plugin_rel_path Optional. Relative path to WP_PLUGIN_DIR where the .mo file resides.
   */
! function load_plugin_textdomain( $domain, $deprecated = false, $plugin_rel_path = false ) {
! 	$locale = get_locale();
! 	/**
! 	 * Filter a plugin's locale.
! 	 *
! 	 * @since 3.0.0
! 	 *
! 	 * @param string $locale The plugin's current locale.
! 	 * @param string $domain Text domain. Unique identifier for retrieving translated strings.
! 	 */
! 	$locale = apply_filters( 'plugin_locale', $locale, $domain );
  
  	if ( false !== $plugin_rel_path	) {
  		$path = WP_PLUGIN_DIR . '/' . trim( $plugin_rel_path, '/' );
! 	} else if ( false !== $deprecated ) {
  		_deprecated_argument( __FUNCTION__, '2.7' );
! 		$path = ABSPATH . trim( $deprecated, '/' );
  	} else {
  		$path = WP_PLUGIN_DIR;
  	}
  
! 	// Load the textdomain according to the plugin first
! 	$mofile = $domain . '-' . $locale . '.mo';
! 	if ( $loaded = load_textdomain( $domain, $path . '/'. $mofile ) )
! 		return $loaded;
! 
! 	// Otherwise, load from the languages directory
! 	$mofile = WP_LANG_DIR . '/plugins/' . $mofile;
  	return load_textdomain( $domain, $mofile );
  }
  
  /**
!  * Load the translated strings for a plugin residing in the mu-plugins directory.
   *
   * @since 3.0.0
   *
!  * @param string $domain             Text domain. Unique identifier for retrieving translated strings.
!  * @param string $mu_plugin_rel_path Relative to WPMU_PLUGIN_DIR directory in which the .mo file resides.
!  *                                   Default empty string.
!  * @return bool True when textdomain is successfully loaded, false otherwise.
   */
  function load_muplugin_textdomain( $domain, $mu_plugin_rel_path = '' ) {
+ 	// duplicate_hook
  	$locale = apply_filters( 'plugin_locale', get_locale(), $domain );
! 	$path = trailingslashit( WPMU_PLUGIN_DIR . '/' . ltrim( $mu_plugin_rel_path, '/' ) );
! 
! 	// Load the textdomain according to the plugin first
! 	$mofile = $domain . '-' . $locale . '.mo';
! 	if ( $loaded = load_textdomain( $domain, $path . $mofile ) )
! 		return $loaded;
! 
! 	// Otherwise, load from the languages directory
! 	$mofile = WP_LANG_DIR . '/plugins/' . $mofile;
! 	return load_textdomain( $domain, $mofile );
  }
  
  /**
!  * Load the theme's translated strings.
   *
   * If the current locale exists as a .mo file in the theme's root directory, it
   * will be included in the translated strings by the $domain.
***************
*** 454,488 ****
   *
   * @since 1.5.0
   *
!  * @param string $domain Unique identifier for retrieving translated strings
   */
  function load_theme_textdomain( $domain, $path = false ) {
! 	$locale = apply_filters( 'theme_locale', get_locale(), $domain );
  
  	if ( ! $path )
  		$path = get_template_directory();
  
! 	// Load the textdomain from the Theme provided location, or theme directory first
  	$mofile = "{$path}/{$locale}.mo";
! 	if ( $loaded = load_textdomain($domain, $mofile) )
  		return $loaded;
  
! 	// Else, load textdomain from the Language directory
  	$mofile = WP_LANG_DIR . "/themes/{$domain}-{$locale}.mo";
! 	return load_textdomain($domain, $mofile);
  }
  
  /**
!  * Loads the child themes translated strings.
   *
!  * If the current locale exists as a .mo file in the child themes root directory, it
!  * will be included in the translated strings by the $domain.
   *
   * The .mo files must be named based on the locale exactly.
   *
   * @since 2.9.0
   *
!  * @param string $domain Unique identifier for retrieving translated strings
   */
  function load_child_theme_textdomain( $domain, $path = false ) {
  	if ( ! $path )
--- 615,662 ----
   *
   * @since 1.5.0
   *
!  * @param string $domain Text domain. Unique identifier for retrieving translated strings.
!  * @param string $path   Optional. Path to the directory containing the .mo file.
!  *                       Default false.
!  * @return bool True when textdomain is successfully loaded, false otherwise.
   */
  function load_theme_textdomain( $domain, $path = false ) {
! 	$locale = get_locale();
! 	/**
! 	 * Filter a theme's locale.
! 	 *
! 	 * @since 3.0.0
! 	 *
! 	 * @param string $locale The theme's current locale.
! 	 * @param string $domain Text domain. Unique identifier for retrieving translated strings.
! 	 */
! 	$locale = apply_filters( 'theme_locale', $locale, $domain );
  
  	if ( ! $path )
  		$path = get_template_directory();
  
! 	// Load the textdomain according to the theme
  	$mofile = "{$path}/{$locale}.mo";
! 	if ( $loaded = load_textdomain( $domain, $mofile ) )
  		return $loaded;
  
! 	// Otherwise, load from the languages directory
  	$mofile = WP_LANG_DIR . "/themes/{$domain}-{$locale}.mo";
! 	return load_textdomain( $domain, $mofile );
  }
  
  /**
!  * Load the child themes translated strings.
   *
!  * If the current locale exists as a .mo file in the child themes
!  * root directory, it will be included in the translated strings by the $domain.
   *
   * The .mo files must be named based on the locale exactly.
   *
   * @since 2.9.0
   *
!  * @param string $domain Text domain. Unique identifier for retrieving translated strings.
!  * @return bool True when the theme textdomain is successfully loaded, false otherwise.
   */
  function load_child_theme_textdomain( $domain, $path = false ) {
  	if ( ! $path )
***************
*** 491,501 ****
  }
  
  /**
!  * Returns the Translations instance for a domain. If there isn't one,
!  * returns empty Translations instance.
   *
!  * @param string $domain
!  * @return object A Translation instance
   */
  function get_translations_for_domain( $domain ) {
  	global $l10n;
--- 665,676 ----
  }
  
  /**
!  * Return the Translations instance for a text domain.
!  *
!  * If there isn't one, returns empty Translations instance.
   *
!  * @param string $domain Text domain. Unique identifier for retrieving translated strings.
!  * @return Translations A Translations instance.
   */
  function get_translations_for_domain( $domain ) {
  	global $l10n;
***************
*** 506,516 ****
  }
  
  /**
!  * Whether there are translations for the domain
   *
   * @since 3.0.0
!  * @param string $domain
!  * @return bool Whether there are translations
   */
  function is_textdomain_loaded( $domain ) {
  	global $l10n;
--- 681,691 ----
  }
  
  /**
!  * Whether there are translations for the text domain.
   *
   * @since 3.0.0
!  * @param string $domain Text domain. Unique identifier for retrieving translated strings.
!  * @return bool Whether there are translations.
   */
  function is_textdomain_loaded( $domain ) {
  	global $l10n;
***************
*** 518,543 ****
  }
  
  /**
!  * Translates role name. Since the role names are in the database and
!  * not in the source there are dummy gettext calls to get them into the POT
!  * file and this function properly translates them back.
   *
   * The before_last_bar() call is needed, because older installs keep the roles
   * using the old context format: 'Role name|User role' and just skipping the
   * content after the last bar is easier than fixing them in the DB. New installs
   * won't suffer from that problem.
   */
  function translate_user_role( $name ) {
  	return translate_with_gettext_context( before_last_bar($name), 'User role' );
  }
  
  /**
!  * Get all available languages based on the presence of *.mo files in a given directory. The default directory is WP_LANG_DIR.
   *
   * @since 3.0.0
   *
!  * @param string $dir A directory in which to search for language files. The default directory is WP_LANG_DIR.
!  * @return array Array of language codes or an empty array if no languages are present. Language codes are formed by stripping the .mo extension from the language file names.
   */
  function get_available_languages( $dir = null ) {
  	$languages = array();
--- 693,728 ----
  }
  
  /**
!  * Translates role name.
!  *
!  * Since the role names are in the database and not in the source there
!  * are dummy gettext calls to get them into the POT file and this function
!  * properly translates them back.
   *
   * The before_last_bar() call is needed, because older installs keep the roles
   * using the old context format: 'Role name|User role' and just skipping the
   * content after the last bar is easier than fixing them in the DB. New installs
   * won't suffer from that problem.
+  *
+  * @since 2.8.0
+  *
+  * @param string $name The role name.
+  * @return string Translated role name on success, original name on failure.
   */
  function translate_user_role( $name ) {
  	return translate_with_gettext_context( before_last_bar($name), 'User role' );
  }
  
  /**
!  * Get all available languages based on the presence of *.mo files in a given directory.
!  *
!  * The default directory is WP_LANG_DIR.
   *
   * @since 3.0.0
   *
!  * @param string $dir A directory to search for language files.
!  *                    Default WP_LANG_DIR.
!  * @return array An array of language codes or an empty array if no languages are present. Language codes are formed by stripping the .mo extension from the language file names.
   */
  function get_available_languages( $dir = null ) {
  	$languages = array();
***************
*** 550,553 ****
  	}
  
  	return $languages;
! }
\ No newline at end of file
--- 735,805 ----
  	}
  
  	return $languages;
! }
! 
! /**
!  * Get installed translations.
!  *
!  * Looks in the wp-content/languages directory for translations of
!  * plugins or themes.
!  *
!  * @since 3.7.0
!  *
!  * @param string $type What to search for. Accepts 'plugins', 'themes', 'core'.
!  * @return array Array of language data.
!  */
! function wp_get_installed_translations( $type ) {
! 	if ( $type !== 'themes' && $type !== 'plugins' && $type !== 'core' )
! 		return array();
! 
! 	$dir = 'core' === $type ? '' : "/$type";
! 
! 	if ( ! is_dir( WP_LANG_DIR ) )
! 		return array();
! 
! 	if ( $dir && ! is_dir( WP_LANG_DIR . $dir ) )
! 		return array();
! 
! 	$files = scandir( WP_LANG_DIR . $dir );
! 	if ( ! $files )
! 		return array();
! 
! 	$language_data = array();
! 
! 	foreach ( $files as $file ) {
! 		if ( '.' === $file[0] || is_dir( $file ) )
! 			continue;
! 		if ( substr( $file, -3 ) !== '.po' )
! 			continue;
! 		if ( ! preg_match( '/(?:(.+)-)?([A-Za-z_]{2,6}).po/', $file, $match ) )
! 			continue;
! 
! 		list( , $textdomain, $language ) = $match;
! 		if ( '' === $textdomain )
! 			$textdomain = 'default';
! 		$language_data[ $textdomain ][ $language ] = wp_get_pomo_file_data( WP_LANG_DIR . "$dir/$file" );
! 	}
! 	return $language_data;
! }
! 
! /**
!  * Extract headers from a PO file.
!  *
!  * @since 3.7.0
!  *
!  * @param string $po_file Path to PO file.
!  * @return array PO file headers.
!  */
! function wp_get_pomo_file_data( $po_file ) {
! 	$headers = get_file_data( $po_file, array(
! 		'POT-Creation-Date'  => '"POT-Creation-Date',
! 		'PO-Revision-Date'   => '"PO-Revision-Date',
! 		'Project-Id-Version' => '"Project-Id-Version',
! 		'X-Generator'        => '"X-Generator',
! 	) );
! 	foreach ( $headers as &$header ) {
! 		// Remove possible contextual '\n' and closing double quote.
! 		$header = preg_replace( '~(\\\n)?"$~', '', $header );
! 	}
! 	return $headers;
! }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/link-template.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/link-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/link-template.php	2013-09-10 23:00:03.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/link-template.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 73,81 ****
   *
   * @since 1.0.0
   *
!  * @param int $id Optional. Post ID.
!  * @param bool $leavename Optional, defaults to false. Whether to keep post name or page name.
!  * @return string
   */
  function get_permalink( $id = 0, $leavename = false ) {
  	$rewritecode = array(
--- 73,81 ----
   *
   * @since 1.0.0
   *
!  * @param int|WP_Post $id Optional. Post ID or post object, defaults to the current post.
!  * @param bool $leavename Optional. Whether to keep post name or page name, defaults to false.
!  * @return string|bool The permalink URL or false if post does not exist.
   */
  function get_permalink( $id = 0, $leavename = false ) {
  	$rewritecode = array(
***************
*** 131,137 ****
  			// show default category in permalinks, without
  			// having to assign it explicitly
  			if ( empty($category) ) {
! 				$default_category = get_category( get_option( 'default_category' ) );
  				$category = is_wp_error( $default_category ) ? '' : $default_category->slug;
  			}
  		}
--- 131,137 ----
  			// show default category in permalinks, without
  			// having to assign it explicitly
  			if ( empty($category) ) {
! 				$default_category = get_term( get_option( 'default_category' ), 'category' );
  				$category = is_wp_error( $default_category ) ? '' : $default_category->slug;
  			}
  		}
***************
*** 662,672 ****
   * @param string $link Optional. Anchor text.
   * @param string $before Optional. Display before edit link.
   * @param string $after Optional. Display after edit link.
!  * @param int|object $tag Tag object or ID
   * @return string HTML content.
   */
  function edit_tag_link( $link = '', $before = '', $after = '', $tag = null ) {
! 	$link = edit_term_link( $link, '', '', false, $tag );
  	echo $before . apply_filters( 'edit_tag_link', $link ) . $after;
  }
  
--- 662,672 ----
   * @param string $link Optional. Anchor text.
   * @param string $before Optional. Display before edit link.
   * @param string $after Optional. Display after edit link.
!  * @param object $tag Tag object.
   * @return string HTML content.
   */
  function edit_tag_link( $link = '', $before = '', $after = '', $tag = null ) {
! 	$link = edit_term_link( $link, '', '', $tag, false );
  	echo $before . apply_filters( 'edit_tag_link', $link ) . $after;
  }
  
***************
*** 709,730 ****
   * @param string $link Optional. Anchor text.
   * @param string $before Optional. Display before edit link.
   * @param string $after Optional. Display after edit link.
!  * @param object $term Term object
   * @return string HTML content.
   */
  function edit_term_link( $link = '', $before = '', $after = '', $term = null, $echo = true ) {
! 	if ( is_null( $term ) ) {
  		$term = get_queried_object();
! 	}
  
  	$tax = get_taxonomy( $term->taxonomy );
! 	if ( !current_user_can($tax->cap->edit_terms) )
  		return;
  
  	if ( empty( $link ) )
  		$link = __('Edit This');
  
! 	$link = '<a href="' . get_edit_term_link( $term->term_id, $term->taxonomy ) . '" title="' . $link . '">' . $link . '</a>';
  	$link = $before . apply_filters( 'edit_term_link', $link, $term->term_id ) . $after;
  
  	if ( $echo )
--- 709,732 ----
   * @param string $link Optional. Anchor text.
   * @param string $before Optional. Display before edit link.
   * @param string $after Optional. Display after edit link.
!  * @param object $term Term object.
   * @return string HTML content.
   */
  function edit_term_link( $link = '', $before = '', $after = '', $term = null, $echo = true ) {
! 	if ( is_null( $term ) )
  		$term = get_queried_object();
! 
! 	if ( ! $term )
! 		return;
  
  	$tax = get_taxonomy( $term->taxonomy );
! 	if ( ! current_user_can( $tax->cap->edit_terms ) )
  		return;
  
  	if ( empty( $link ) )
  		$link = __('Edit This');
  
! 	$link = '<a href="' . get_edit_term_link( $term->term_id, $term->taxonomy ) . '">' . $link . '</a>';
  	$link = $before . apply_filters( 'edit_term_link', $link, $term->term_id ) . $after;
  
  	if ( $echo )
***************
*** 935,941 ****
  		$link = __('Edit This');
  
  	$post_type_obj = get_post_type_object( $post->post_type );
! 	$link = '<a class="post-edit-link" href="' . $url . '" title="' . esc_attr( $post_type_obj->labels->edit_item ) . '">' . $link . '</a>';
  	echo $before . apply_filters( 'edit_post_link', $link, $post->ID ) . $after;
  }
  
--- 937,943 ----
  		$link = __('Edit This');
  
  	$post_type_obj = get_post_type_object( $post->post_type );
! 	$link = '<a class="post-edit-link" href="' . $url . '">' . $link . '</a>';
  	echo $before . apply_filters( 'edit_post_link', $link, $post->ID ) . $after;
  }
  
***************
*** 1009,1015 ****
  	if ( null === $link )
  		$link = __('Edit This');
  
! 	$link = '<a class="comment-edit-link" href="' . get_edit_comment_link( $comment->comment_ID ) . '" title="' . esc_attr__( 'Edit comment' ) . '">' . $link . '</a>';
  	echo $before . apply_filters( 'edit_comment_link', $link, $comment->comment_ID ) . $after;
  }
  
--- 1011,1017 ----
  	if ( null === $link )
  		$link = __('Edit This');
  
! 	$link = '<a class="comment-edit-link" href="' . get_edit_comment_link( $comment->comment_ID ) . '">' . $link . '</a>';
  	echo $before . apply_filters( 'edit_comment_link', $link, $comment->comment_ID ) . $after;
  }
  
***************
*** 1050,1056 ****
  	if ( empty($link) )
  		$link = __('Edit This');
  
! 	$link = '<a href="' . get_edit_bookmark_link( $bookmark ) . '" title="' . esc_attr__( 'Edit Link' ) . '">' . $link . '</a>';
  	echo $before . apply_filters( 'edit_bookmark_link', $link, $bookmark->link_id ) . $after;
  }
  
--- 1052,1058 ----
  	if ( empty($link) )
  		$link = __('Edit This');
  
! 	$link = '<a href="' . get_edit_bookmark_link( $bookmark ) . '">' . $link . '</a>';
  	echo $before . apply_filters( 'edit_bookmark_link', $link, $bookmark->link_id ) . $after;
  }
  
***************
*** 1335,1352 ****
  	return get_posts( array('numberposts' => 1, 'category' => $categories, 'order' => $order, 'update_post_term_cache' => false, 'update_post_meta_cache' => false) );
  }
  
  /**
   * Display previous post link that is adjacent to the current post.
   *
   * @since 1.5.0
   *
   * @param string $format Optional. Link anchor format.
   * @param string $link Optional. Link permalink format.
   * @param bool $in_same_cat Optional. Whether link should be in a same category.
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   */
! function previous_post_link($format='&laquo; %link', $link='%title', $in_same_cat = false, $excluded_categories = '') {
! 	adjacent_post_link($format, $link, $in_same_cat, $excluded_categories, true);
  }
  
  /**
--- 1337,1386 ----
  	return get_posts( array('numberposts' => 1, 'category' => $categories, 'order' => $order, 'update_post_term_cache' => false, 'update_post_meta_cache' => false) );
  }
  
+ /*
+  * Get previous post link that is adjacent to the current post.
+  *
+  * @since 3.7.0
+  *
+  * @param string $format Optional. Link anchor format.
+  * @param string $link Optional. Link permalink format.
+  * @param bool $in_same_cat Optional. Whether link should be in same category.
+  * @param string $excluded_categories Optional. Excluded categories IDs.
+  * @return string
+  */
+ function get_previous_post_link( $format = '&laquo; %link', $link = '%title', $in_same_cat = false, $excluded_categories = '' ) {
+ 	return get_adjacent_post_link( $format, $link, $in_same_cat, $excluded_categories, true );
+ }
+ 
  /**
   * Display previous post link that is adjacent to the current post.
   *
   * @since 1.5.0
+  * @uses get_previous_post_link()
   *
   * @param string $format Optional. Link anchor format.
   * @param string $link Optional. Link permalink format.
   * @param bool $in_same_cat Optional. Whether link should be in a same category.
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   */
! function previous_post_link( $format = '&laquo; %link', $link = '%title', $in_same_cat = false, $excluded_categories = '' ) {
! 	echo get_previous_post_link( $format, $link, $in_same_cat, $excluded_categories );
! }
! 
! /**
!  * Get previous post link that is adjacent to the current post.
!  *
!  * @since 3.7.0
!  * @uses get_next_post_link()
!  *
!  * @param string $format Optional. Link anchor format.
!  * @param string $link Optional. Link permalink format.
!  * @param bool $in_same_cat Optional. Whether link should be in same category.
!  * @param string $excluded_categories Optional. Excluded categories IDs.
!  * @return string
!  */
! function get_next_post_link( $format = '&laquo; %link', $link = '%title', $in_same_cat = false, $excluded_categories = '' ) {
! 	return get_adjacent_post_link( $format, $link, $in_same_cat, $excluded_categories, false );
  }
  
  /**
***************
*** 1359,1382 ****
   * @param bool $in_same_cat Optional. Whether link should be in a same category.
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   */
! function next_post_link($format='%link &raquo;', $link='%title', $in_same_cat = false, $excluded_categories = '') {
! 	adjacent_post_link($format, $link, $in_same_cat, $excluded_categories, false);
  }
  
  /**
!  * Display adjacent post link.
   *
   * Can be either next post link or previous.
   *
!  * @since 2.5.0
   *
   * @param string $format Link anchor format.
   * @param string $link Link permalink format.
   * @param bool $in_same_cat Optional. Whether link should be in a same category.
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   * @param bool $previous Optional, default is true. Whether to display link to previous or next post.
   */
! function adjacent_post_link( $format, $link, $in_same_cat = false, $excluded_categories = '', $previous = true ) {
  	if ( $previous && is_attachment() )
  		$post = get_post( get_post()->post_parent );
  	else
--- 1393,1417 ----
   * @param bool $in_same_cat Optional. Whether link should be in a same category.
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   */
! function next_post_link( $format = '%link &raquo;', $link = '%title', $in_same_cat = false, $excluded_categories = '' ) {
! 	 echo get_next_post_link( $format, $link, $in_same_cat, $excluded_categories );
  }
  
  /**
!  * Get adjacent post link.
   *
   * Can be either next post link or previous.
   *
!  * @since 3.7.0
   *
   * @param string $format Link anchor format.
   * @param string $link Link permalink format.
   * @param bool $in_same_cat Optional. Whether link should be in a same category.
   * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
   * @param bool $previous Optional, default is true. Whether to display link to previous or next post.
+  * @return string
   */
! function get_adjacent_post_link( $format, $link, $in_same_cat = false, $excluded_categories = '', $previous = true ) {
  	if ( $previous && is_attachment() )
  		$post = get_post( get_post()->post_parent );
  	else
***************
*** 1390,1395 ****
--- 1425,1431 ----
  		if ( empty( $post->post_title ) )
  			$title = $previous ? __( 'Previous Post' ) : __( 'Next Post' );
  
+ 		/** This filter is documented in wp-includes/post-template.php */
  		$title = apply_filters( 'the_title', $title, $post->ID );
  		$date = mysql2date( get_option( 'date_format' ), $post->post_date );
  		$rel = $previous ? 'prev' : 'next';
***************
*** 1404,1410 ****
  
  	$adjacent = $previous ? 'previous' : 'next';
  
! 	echo apply_filters( "{$adjacent}_post_link", $output, $format, $link, $post );
  }
  
  /**
--- 1440,1465 ----
  
  	$adjacent = $previous ? 'previous' : 'next';
  
! 	return apply_filters( "{$adjacent}_post_link", $output, $format, $link, $post );
! }
! 
! /**
!  * Display adjacent post link.
!  *
!  * Can be either next post link or previous.
!  *
!  * @since 2.5.0
!  * @uses get_adjacent_post_link()
!  *
!  * @param string $format Link anchor format.
!  * @param string $link Link permalink format.
!  * @param bool $in_same_cat Optional. Whether link should be in a same category.
!  * @param array|string $excluded_categories Optional. Array or comma-separated list of excluded category IDs.
!  * @param bool $previous Optional, default is true. Whether to display link to previous or next post.
!  * @return string
!  */
! function adjacent_post_link( $format, $link, $in_same_cat = false, $excluded_categories = '', $previous = true ) {
! 	echo get_adjacent_post_link( $format, $link, $in_same_cat, $excluded_categories, $previous );
  }
  
  /**
***************
*** 1913,1919 ****
  	}
  
  	if ( ! in_array( $scheme, array( 'http', 'https', 'relative' ) ) ) {
! 		if ( is_ssl() && ! is_admin() )
  			$scheme = 'https';
  		else
  			$scheme = parse_url( $url, PHP_URL_SCHEME );
--- 1968,1974 ----
  	}
  
  	if ( ! in_array( $scheme, array( 'http', 'https', 'relative' ) ) ) {
! 		if ( is_ssl() && ! is_admin() && 'wp-login.php' !== $GLOBALS['pagenow'] )
  			$scheme = 'https';
  		else
  			$scheme = parse_url( $url, PHP_URL_SCHEME );
***************
*** 2358,2377 ****
  
  	global $wp_query;
  	$post_id = 0;
! 	if ( 'query' == $context && is_single() ) {
  		$post_id = $wp_query->get_queried_object_id();
  	} elseif ( 'post' == $context ) {
! 		$post = get_post($id);
! 		$post_id = $post->ID;
  	}
  
  	$shortlink = '';
  
! 	// Return p= link for posts.
! 	if ( !empty($post_id) && '' != get_option('permalink_structure') ) {
! 		$post = get_post($post_id);
! 		if ( isset($post->post_type) && 'post' == $post->post_type )
! 			$shortlink = home_url('?p=' . $post->ID);
  	}
  
  	return apply_filters('get_shortlink', $shortlink, $id, $context, $allow_slugs);
--- 2413,2434 ----
  
  	global $wp_query;
  	$post_id = 0;
! 	if ( 'query' == $context && is_singular() ) {
  		$post_id = $wp_query->get_queried_object_id();
+ 		$post = get_post( $post_id );
  	} elseif ( 'post' == $context ) {
! 		$post = get_post( $id );
! 		if ( ! empty( $post->ID ) )
! 			$post_id = $post->ID;
  	}
  
  	$shortlink = '';
  
! 	// Return p= link for all public post types.
! 	if ( ! empty( $post_id ) ) {
! 		$post_type = get_post_type_object( $post->post_type );
! 		if ( $post_type->public )
! 			$shortlink = home_url('?p=' . $post_id);
  	}
  
  	return apply_filters('get_shortlink', $shortlink, $id, $context, $allow_slugs);
